﻿#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
This experiment was created using PsychoPy3 Experiment Builder (v2022.1.2),
    on September 06, 2022, at 22:53
If you publish work using this script the most relevant publication is:

    Peirce J, Gray JR, Simpson S, MacAskill M, Höchenberger R, Sogo H, Kastman E, Lindeløv JK. (2019) 
        PsychoPy2: Experiments in behavior made easy Behav Res 51: 195. 
        https://doi.org/10.3758/s13428-018-01193-y

"""

import psychopy
psychopy.useVersion('2022.1.2')


from psychopy import locale_setup
from psychopy import prefs
from psychopy import sound, gui, visual, core, data, event, logging, clock, colors, layout
from psychopy.constants import (NOT_STARTED, STARTED, PLAYING, PAUSED,
                                STOPPED, FINISHED, PRESSED, RELEASED, FOREVER)

import numpy as np  # whole numpy lib is available, prepend 'np.'
from numpy import (sin, cos, tan, log, log10, pi, average,
                   sqrt, std, deg2rad, rad2deg, linspace, asarray)
from numpy.random import random, randint, normal, shuffle, choice as randchoice
import os  # handy system and path functions
import sys  # to get file system encoding

import psychopy.iohub as io
from psychopy.hardware import keyboard

ax = 0
ay = 0
bx = 0
by = 0

ax = 0
ay = 0
bx = 0
by = 0

ax = 0
ay = 0
bx = 0
by = 0



# Ensure that relative paths start from the same directory as this script
_thisDir = os.path.dirname(os.path.abspath(__file__))
os.chdir(_thisDir)
# Store info about the experiment session
psychopyVersion = '2022.1.2'
expName = 'hu4in1_on'  # from the Builder filename that created this script
expInfo = {'participant': ''}
dlg = gui.DlgFromDict(dictionary=expInfo, sortKeys=False, title=expName)
if dlg.OK == False:
    core.quit()  # user pressed cancel
expInfo['date'] = data.getDateStr()  # add a simple timestamp
expInfo['expName'] = expName
expInfo['psychopyVersion'] = psychopyVersion

# Data file name stem = absolute path + name; later add .psyexp, .csv, .log, etc
filename = _thisDir + os.sep + u'data/%s_%s_%s' % (expInfo['participant'], expName, expInfo['date'])

# An ExperimentHandler isn't essential but helps with data saving
thisExp = data.ExperimentHandler(name=expName, version='',
    extraInfo=expInfo, runtimeInfo=None,
    originPath='C:\\Users\\17703\\Desktop\\HuRein15\\Rein18_lastrun.py',
    savePickle=True, saveWideText=True,
    dataFileName=filename)
logging.console.setLevel(logging.WARNING)  # this outputs to the screen, not a file

endExpNow = False  # flag for 'escape' or other condition => quit the exp
frameTolerance = 0.001  # how close to onset before 'same' frame

# Start Code - component code to be run after the window creation

# Setup the Window
win = visual.Window(
    size=[1440, 900], fullscr=True, screen=0, 
    winType='pyglet', allowGUI=False, allowStencil=False,
    monitor='testMonitor', color='white', colorSpace='rgb',
    blendMode='avg', useFBO=True, 
    units='height')
# store frame rate of monitor if we can measure it
expInfo['frameRate'] = win.getActualFrameRate()
if expInfo['frameRate'] != None:
    frameDur = 1.0 / round(expInfo['frameRate'])
else:
    frameDur = 1.0 / 60.0  # could not measure, so guess
# Setup ioHub
ioConfig = {}

# Setup iohub keyboard
ioConfig['Keyboard'] = dict(use_keymap='psychopy')

ioSession = '1'
if 'session' in expInfo:
    ioSession = str(expInfo['session'])
ioServer = io.launchHubServer(window=win, **ioConfig)
eyetracker = None

# create a default keyboard (e.g. to check for escape)
defaultKeyboard = keyboard.Keyboard(backend='iohub')

# Initialize components for Routine "instructions"
instructionsClock = core.Clock()
text = visual.TextStim(win=win, name='text',
    text='On each trial you will see a stimulus to the right.\nSome stimuli belong to Category A.\nSome stimuli belong to Category B.\nCategory A and B stimuli will occur equally often.\n\nPress the A key for Category A trials.\nPress the B key for Category B trials.\n\nAt first you will need to guess, but then you will learn to classify accurately.\nWe will give you feedback after each trial.\n\nFor correct responses you will GAIN 1 POINT.\n\nFor incorrect responses you will LOSE 1 POINT.\nFor incorrect responses you will also have a 4 second timeout period.\n\nPress space to acknowledge that you have read all of these instructions \nand to start the trials.',
    font='Open Sans',
    pos=(0, 0), height=0.03, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_resp_3 = keyboard.Keyboard()

# Initialize components for Routine "immed_training"
immed_trainingClock = core.Clock()
image_4 = visual.ImageStim(
    win=win,
    name='image_4', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.8, 1.3),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=False, depth=-1.0)
key_resp_4 = keyboard.Keyboard()
A_text_3 = visual.TextStim(win=win, name='A_text_3',
    text='',
    font='Open Sans',
    pos=[0,0], height=0.15, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
B_text_3 = visual.TextStim(win=win, name='B_text_3',
    text='',
    font='Open Sans',
    pos=[0,0], height=0.15, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);

# Initialize components for Routine "feedback_im"
feedback_imClock = core.Clock()
corr_history = []
score = 0
trial_num = 0
Feedback_img_list = []
Feedback_onset = ''
show_stim = ''
response = ''
timeout = 0

image_5 = visual.ImageStim(
    win=win,
    name='image_5', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.8, 1.3),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=False, depth=-1.0)
text_3 = visual.TextStim(win=win, name='text_3',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "feedback_instructions"
feedback_instructionsClock = core.Clock()
text_2 = visual.TextStim(win=win, name='text_2',
    text='Good Job! You learned that task.\n\nNow you will learn a series of new tasks in just the same way.\n\nSometimes you will wait a few seconds after a trial before your feedback.\n\nSometimes you will do 6 trials, then get feedback on all trials at once.\n\nSometimes you will receive ONE BEHIND feedback: after Trial 2, you will get feedback on Trial 1, after Trial 3, feedback on Trial 2, and so on.\n\nBut your job stays the same. Just learn to classify A and B stimuli correctly.\n\nPress space to acknowledge that you have read these instructions and to start the trials.',
    font='Open Sans',
    pos=(0, 0), height=0.03, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=0.0);
key_resp_5 = keyboard.Keyboard()

# Initialize components for Routine "trial"
trialClock = core.Clock()
image = visual.ImageStim(
    win=win,
    name='image', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.8, 1.3),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=False, depth=-1.0)
key_resp = keyboard.Keyboard()
A_text = visual.TextStim(win=win, name='A_text',
    text='',
    font='Open Sans',
    pos=[0,0], height=0.15, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
B_text = visual.TextStim(win=win, name='B_text',
    text='',
    font='Open Sans',
    pos=[0,0], height=0.15, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);

# Initialize components for Routine "feedback"
feedbackClock = core.Clock()
corr_history = []
score = 0
Feedback_img_list = []
Feedback_onset = ''
show_stim = ''
response = ''
timeout = 0
conditional = True

image_2 = visual.ImageStim(
    win=win,
    name='image_2', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.8, 1.3),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=False, depth=-1.0)
fdbk = visual.TextStim(win=win, name='fdbk',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "def_feedback"
def_feedbackClock = core.Clock()
def1 = ' '
def2 = ' '
def3 = ' '
def4 = ' '
def5 = ' '
def6 = ' '
deferred_trial1 = visual.TextStim(win=win, name='deferred_trial1',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
deferred_trial2 = visual.TextStim(win=win, name='deferred_trial2',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
deferred_trial3 = visual.TextStim(win=win, name='deferred_trial3',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
deferred_trial4 = visual.TextStim(win=win, name='deferred_trial4',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
deferred_trial5 = visual.TextStim(win=win, name='deferred_trial5',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);
deferred_trial6 = visual.TextStim(win=win, name='deferred_trial6',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-6.0);

# Initialize components for Routine "trial"
trialClock = core.Clock()
image = visual.ImageStim(
    win=win,
    name='image', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.8, 1.3),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=False, depth=-1.0)
key_resp = keyboard.Keyboard()
A_text = visual.TextStim(win=win, name='A_text',
    text='',
    font='Open Sans',
    pos=[0,0], height=0.15, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
B_text = visual.TextStim(win=win, name='B_text',
    text='',
    font='Open Sans',
    pos=[0,0], height=0.15, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);

# Initialize components for Routine "feedback2"
feedback2Clock = core.Clock()
corr_history = []
score = 0
trial_num = 0
Feedback_img_list = []
Feedback_onset = ''
show_stim = ''
response = ''
timeout = 0
conditional = True
task_ctr = 1

image_6 = visual.ImageStim(
    win=win,
    name='image_6', 
    image='sin', mask=None, anchor='center',
    ori=0.0, pos=(0, 0), size=(1.8, 1.3),
    color=[1,1,1], colorSpace='rgb', opacity=None,
    flipHoriz=False, flipVert=False,
    texRes=128.0, interpolate=False, depth=-1.0)
fdbk_2 = visual.TextStim(win=win, name='fdbk_2',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);

# Initialize components for Routine "def_feedback"
def_feedbackClock = core.Clock()
def1 = ' '
def2 = ' '
def3 = ' '
def4 = ' '
def5 = ' '
def6 = ' '
deferred_trial1 = visual.TextStim(win=win, name='deferred_trial1',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-1.0);
deferred_trial2 = visual.TextStim(win=win, name='deferred_trial2',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-2.0);
deferred_trial3 = visual.TextStim(win=win, name='deferred_trial3',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-3.0);
deferred_trial4 = visual.TextStim(win=win, name='deferred_trial4',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-4.0);
deferred_trial5 = visual.TextStim(win=win, name='deferred_trial5',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-5.0);
deferred_trial6 = visual.TextStim(win=win, name='deferred_trial6',
    text='',
    font='Open Sans',
    pos=(0, 0), height=0.05, wrapWidth=None, ori=0.0, 
    color='black', colorSpace='rgb', opacity=None, 
    languageStyle='LTR',
    depth=-6.0);

# Create some handy timers
globalClock = core.Clock()  # to track the time since experiment started
routineTimer = core.CountdownTimer()  # to track time remaining of each (non-slip) routine 

# ------Prepare to start Routine "instructions"-------
continueRoutine = True
# update component parameters for each repeat
key_resp_3.keys = []
key_resp_3.rt = []
_key_resp_3_allKeys = []
# keep track of which components have finished
instructionsComponents = [text, key_resp_3]
for thisComponent in instructionsComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
instructionsClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "instructions"-------
while continueRoutine:
    # get current time
    t = instructionsClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=instructionsClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text* updates
    if text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text.frameNStart = frameN  # exact frame index
        text.tStart = t  # local t and not account for scr refresh
        text.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text, 'tStartRefresh')  # time at next scr refresh
        text.setAutoDraw(True)
    
    # *key_resp_3* updates
    waitOnFlip = False
    if key_resp_3.status == NOT_STARTED and tThisFlip >= 0.5-frameTolerance:
        # keep track of start time/frame for later
        key_resp_3.frameNStart = frameN  # exact frame index
        key_resp_3.tStart = t  # local t and not account for scr refresh
        key_resp_3.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp_3, 'tStartRefresh')  # time at next scr refresh
        key_resp_3.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp_3.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp_3.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp_3.status == STARTED and not waitOnFlip:
        theseKeys = key_resp_3.getKeys(keyList=['space'], waitRelease=False)
        _key_resp_3_allKeys.extend(theseKeys)
        if len(_key_resp_3_allKeys):
            key_resp_3.keys = _key_resp_3_allKeys[-1].name  # just the last key pressed
            key_resp_3.rt = _key_resp_3_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in instructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "instructions"-------
for thisComponent in instructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text.started', text.tStartRefresh)
thisExp.addData('text.stopped', text.tStopRefresh)
# check responses
if key_resp_3.keys in ['', [], None]:  # No response was made
    key_resp_3.keys = None
thisExp.addData('key_resp_3.keys',key_resp_3.keys)
if key_resp_3.keys != None:  # we had a response
    thisExp.addData('key_resp_3.rt', key_resp_3.rt)
thisExp.addData('key_resp_3.started', key_resp_3.tStartRefresh)
thisExp.addData('key_resp_3.stopped', key_resp_3.tStopRefresh)
thisExp.nextEntry()
# the Routine "instructions" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials_3 = data.TrialHandler(nReps=50.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Immed1.xlsx'),
    seed=None, name='trials_3')
thisExp.addLoop(trials_3)  # add the loop to the experiment
thisTrial_3 = trials_3.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial_3.rgb)
if thisTrial_3 != None:
    for paramName in thisTrial_3:
        exec('{} = thisTrial_3[paramName]'.format(paramName))

for thisTrial_3 in trials_3:
    currentLoop = trials_3
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_3.rgb)
    if thisTrial_3 != None:
        for paramName in thisTrial_3:
            exec('{} = thisTrial_3[paramName]'.format(paramName))
    
    # ------Prepare to start Routine "immed_training"-------
    continueRoutine = True
    # update component parameters for each repeat
    # immediate feedback
    if Feedback_Type == 'Immediate':
        ax = -.6
        ay = .01
        bx = -.25
        by = .01
        
    # delayed feedback
    if Feedback_Type == 'Delayed':
        ax = -.6
        ay = .01
        bx = -.25
        by = .01
        
    # oneback feedback
    if Feedback_Type == 'Oneback':
        if Top_Bott == 'Top':
            ax =  -.6
            ay = .27
            bx = -.25
            by = .27
        if Top_Bott == 'Bottom':
            ax = -.6
            ay = -.3
            bx = -.25
            by = -.3
            
    # deferred feedback        
    if Feedback_Type == 'Deferred':
        ax = -.6
        ay = .01
        bx = -.25
        by = .01
    
    
    image_4.setImage(Stim)
    key_resp_4.keys = []
    key_resp_4.rt = []
    _key_resp_4_allKeys = []
    A_text_3.setPos((ax,ay))
    A_text_3.setText('A')
    B_text_3.setPos((bx,by))
    B_text_3.setText('B')
    # keep track of which components have finished
    immed_trainingComponents = [image_4, key_resp_4, A_text_3, B_text_3]
    for thisComponent in immed_trainingComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    immed_trainingClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "immed_training"-------
    while continueRoutine:
        # get current time
        t = immed_trainingClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=immed_trainingClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *image_4* updates
        if image_4.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            image_4.frameNStart = frameN  # exact frame index
            image_4.tStart = t  # local t and not account for scr refresh
            image_4.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(image_4, 'tStartRefresh')  # time at next scr refresh
            image_4.setAutoDraw(True)
        
        # *key_resp_4* updates
        waitOnFlip = False
        if key_resp_4.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            key_resp_4.frameNStart = frameN  # exact frame index
            key_resp_4.tStart = t  # local t and not account for scr refresh
            key_resp_4.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(key_resp_4, 'tStartRefresh')  # time at next scr refresh
            key_resp_4.status = STARTED
            # keyboard checking is just starting
            waitOnFlip = True
            win.callOnFlip(key_resp_4.clock.reset)  # t=0 on next screen flip
            win.callOnFlip(key_resp_4.clearEvents, eventType='keyboard')  # clear events on next screen flip
        if key_resp_4.status == STARTED and not waitOnFlip:
            theseKeys = key_resp_4.getKeys(keyList=['a','b'], waitRelease=False)
            _key_resp_4_allKeys.extend(theseKeys)
            if len(_key_resp_4_allKeys):
                key_resp_4.keys = _key_resp_4_allKeys[-1].name  # just the last key pressed
                key_resp_4.rt = _key_resp_4_allKeys[-1].rt
                # was this correct?
                if (key_resp_4.keys == str(Corr_Ans)) or (key_resp_4.keys == Corr_Ans):
                    key_resp_4.corr = 1
                else:
                    key_resp_4.corr = 0
                # a response ends the routine
                continueRoutine = False
        
        # *A_text_3* updates
        if A_text_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            A_text_3.frameNStart = frameN  # exact frame index
            A_text_3.tStart = t  # local t and not account for scr refresh
            A_text_3.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(A_text_3, 'tStartRefresh')  # time at next scr refresh
            A_text_3.setAutoDraw(True)
        
        # *B_text_3* updates
        if B_text_3.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            B_text_3.frameNStart = frameN  # exact frame index
            B_text_3.tStart = t  # local t and not account for scr refresh
            B_text_3.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(B_text_3, 'tStartRefresh')  # time at next scr refresh
            B_text_3.setAutoDraw(True)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in immed_trainingComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "immed_training"-------
    for thisComponent in immed_trainingComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    trials_3.addData('image_4.started', image_4.tStartRefresh)
    trials_3.addData('image_4.stopped', image_4.tStopRefresh)
    # check responses
    if key_resp_4.keys in ['', [], None]:  # No response was made
        key_resp_4.keys = None
        # was no response the correct answer?!
        if str(Corr_Ans).lower() == 'none':
           key_resp_4.corr = 1;  # correct non-response
        else:
           key_resp_4.corr = 0;  # failed to respond (incorrectly)
    # store data for trials_3 (TrialHandler)
    trials_3.addData('key_resp_4.keys',key_resp_4.keys)
    trials_3.addData('key_resp_4.corr', key_resp_4.corr)
    if key_resp_4.keys != None:  # we had a response
        trials_3.addData('key_resp_4.rt', key_resp_4.rt)
    trials_3.addData('key_resp_4.started', key_resp_4.tStartRefresh)
    trials_3.addData('key_resp_4.stopped', key_resp_4.tStopRefresh)
    trials_3.addData('A_text_3.started', A_text_3.tStartRefresh)
    trials_3.addData('A_text_3.stopped', A_text_3.tStopRefresh)
    trials_3.addData('B_text_3.started', B_text_3.tStartRefresh)
    trials_3.addData('B_text_3.stopped', B_text_3.tStopRefresh)
    # the Routine "immed_training" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    
    # ------Prepare to start Routine "feedback_im"-------
    continueRoutine = True
    # update component parameters for each repeat
    # append the last accuracy value
    corr_history.append(key_resp_4.corr)
    Feedback_img_list.append(Feedback_img)
    trial_num = trials_3.thisN + 1
    
    feedback_onset = 0
    feedback_img_onset = 0
    show_stim = 'images/white.jpg'
    if corr_history[-1] == 1:
        score = score + 1
        response = "Correct +1 point. Total points: " + str(score)
        timeout = 1.5
    else:
        score = score - 1
        response = "Incorrect -1 point. Total points: " + str(score)
        timeout = 4
    
    
    thisExp.addData('corr_history',corr_history)
    image_5.setImage(show_stim)
    text_3.setText(response)
    # keep track of which components have finished
    feedback_imComponents = [image_5, text_3]
    for thisComponent in feedback_imComponents:
        thisComponent.tStart = None
        thisComponent.tStop = None
        thisComponent.tStartRefresh = None
        thisComponent.tStopRefresh = None
        if hasattr(thisComponent, 'status'):
            thisComponent.status = NOT_STARTED
    # reset timers
    t = 0
    _timeToFirstFrame = win.getFutureFlipTime(clock="now")
    feedback_imClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
    frameN = -1
    
    # -------Run Routine "feedback_im"-------
    while continueRoutine:
        # get current time
        t = feedback_imClock.getTime()
        tThisFlip = win.getFutureFlipTime(clock=feedback_imClock)
        tThisFlipGlobal = win.getFutureFlipTime(clock=None)
        frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
        # update/draw components on each frame
        
        # *image_5* updates
        if image_5.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
            # keep track of start time/frame for later
            image_5.frameNStart = frameN  # exact frame index
            image_5.tStart = t  # local t and not account for scr refresh
            image_5.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(image_5, 'tStartRefresh')  # time at next scr refresh
            image_5.setAutoDraw(True)
        if image_5.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > image_5.tStartRefresh + feedback_img_onset + timeout-frameTolerance:
                # keep track of stop time/frame for later
                image_5.tStop = t  # not accounting for scr refresh
                image_5.frameNStop = frameN  # exact frame index
                win.timeOnFlip(image_5, 'tStopRefresh')  # time at next scr refresh
                image_5.setAutoDraw(False)
        
        # *text_3* updates
        if text_3.status == NOT_STARTED and tThisFlip >= feedback_onset-frameTolerance:
            # keep track of start time/frame for later
            text_3.frameNStart = frameN  # exact frame index
            text_3.tStart = t  # local t and not account for scr refresh
            text_3.tStartRefresh = tThisFlipGlobal  # on global time
            win.timeOnFlip(text_3, 'tStartRefresh')  # time at next scr refresh
            text_3.setAutoDraw(True)
        if text_3.status == STARTED:
            # is it time to stop? (based on global clock, using actual start)
            if tThisFlipGlobal > text_3.tStartRefresh + timeout-frameTolerance:
                # keep track of stop time/frame for later
                text_3.tStop = t  # not accounting for scr refresh
                text_3.frameNStop = frameN  # exact frame index
                win.timeOnFlip(text_3, 'tStopRefresh')  # time at next scr refresh
                text_3.setAutoDraw(False)
        
        # check for quit (typically the Esc key)
        if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
            core.quit()
        
        # check if all components have finished
        if not continueRoutine:  # a component has requested a forced-end of Routine
            break
        continueRoutine = False  # will revert to True if at least one component still running
        for thisComponent in feedback_imComponents:
            if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                continueRoutine = True
                break  # at least one component has not yet finished
        
        # refresh the screen
        if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
            win.flip()
    
    # -------Ending Routine "feedback_im"-------
    for thisComponent in feedback_imComponents:
        if hasattr(thisComponent, "setAutoDraw"):
            thisComponent.setAutoDraw(False)
    last30 = corr_history[-10:]
    avg_acc = (sum(last30))/10
    if(avg_acc >=0.8 and trial_num >= 10):
        trials_3.finished = True
    
    trials_3.addData('image_5.started', image_5.tStartRefresh)
    trials_3.addData('image_5.stopped', image_5.tStopRefresh)
    trials_3.addData('text_3.started', text_3.tStartRefresh)
    trials_3.addData('text_3.stopped', text_3.tStopRefresh)
    # the Routine "feedback_im" was not non-slip safe, so reset the non-slip timer
    routineTimer.reset()
    thisExp.nextEntry()
    
# completed 50.0 repeats of 'trials_3'


# ------Prepare to start Routine "feedback_instructions"-------
continueRoutine = True
# update component parameters for each repeat
key_resp_5.keys = []
key_resp_5.rt = []
_key_resp_5_allKeys = []
# keep track of which components have finished
feedback_instructionsComponents = [text_2, key_resp_5]
for thisComponent in feedback_instructionsComponents:
    thisComponent.tStart = None
    thisComponent.tStop = None
    thisComponent.tStartRefresh = None
    thisComponent.tStopRefresh = None
    if hasattr(thisComponent, 'status'):
        thisComponent.status = NOT_STARTED
# reset timers
t = 0
_timeToFirstFrame = win.getFutureFlipTime(clock="now")
feedback_instructionsClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
frameN = -1

# -------Run Routine "feedback_instructions"-------
while continueRoutine:
    # get current time
    t = feedback_instructionsClock.getTime()
    tThisFlip = win.getFutureFlipTime(clock=feedback_instructionsClock)
    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
    # update/draw components on each frame
    
    # *text_2* updates
    if text_2.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        text_2.frameNStart = frameN  # exact frame index
        text_2.tStart = t  # local t and not account for scr refresh
        text_2.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(text_2, 'tStartRefresh')  # time at next scr refresh
        text_2.setAutoDraw(True)
    
    # *key_resp_5* updates
    waitOnFlip = False
    if key_resp_5.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
        # keep track of start time/frame for later
        key_resp_5.frameNStart = frameN  # exact frame index
        key_resp_5.tStart = t  # local t and not account for scr refresh
        key_resp_5.tStartRefresh = tThisFlipGlobal  # on global time
        win.timeOnFlip(key_resp_5, 'tStartRefresh')  # time at next scr refresh
        key_resp_5.status = STARTED
        # keyboard checking is just starting
        waitOnFlip = True
        win.callOnFlip(key_resp_5.clock.reset)  # t=0 on next screen flip
        win.callOnFlip(key_resp_5.clearEvents, eventType='keyboard')  # clear events on next screen flip
    if key_resp_5.status == STARTED and not waitOnFlip:
        theseKeys = key_resp_5.getKeys(keyList=['space'], waitRelease=False)
        _key_resp_5_allKeys.extend(theseKeys)
        if len(_key_resp_5_allKeys):
            key_resp_5.keys = _key_resp_5_allKeys[-1].name  # just the last key pressed
            key_resp_5.rt = _key_resp_5_allKeys[-1].rt
            # a response ends the routine
            continueRoutine = False
    
    # check for quit (typically the Esc key)
    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
        core.quit()
    
    # check if all components have finished
    if not continueRoutine:  # a component has requested a forced-end of Routine
        break
    continueRoutine = False  # will revert to True if at least one component still running
    for thisComponent in feedback_instructionsComponents:
        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
            continueRoutine = True
            break  # at least one component has not yet finished
    
    # refresh the screen
    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
        win.flip()

# -------Ending Routine "feedback_instructions"-------
for thisComponent in feedback_instructionsComponents:
    if hasattr(thisComponent, "setAutoDraw"):
        thisComponent.setAutoDraw(False)
thisExp.addData('text_2.started', text_2.tStartRefresh)
thisExp.addData('text_2.stopped', text_2.tStopRefresh)
# check responses
if key_resp_5.keys in ['', [], None]:  # No response was made
    key_resp_5.keys = None
thisExp.addData('key_resp_5.keys',key_resp_5.keys)
if key_resp_5.keys != None:  # we had a response
    thisExp.addData('key_resp_5.rt', key_resp_5.rt)
thisExp.addData('key_resp_5.started', key_resp_5.tStartRefresh)
thisExp.addData('key_resp_5.stopped', key_resp_5.tStopRefresh)
thisExp.nextEntry()
# the Routine "feedback_instructions" was not non-slip safe, so reset the non-slip timer
routineTimer.reset()

# set up handler to look after randomisation of conditions etc
trials_2 = data.TrialHandler(nReps=1.0, method='sequential', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('TaskList1.xlsx'),
    seed=None, name='trials_2')
thisExp.addLoop(trials_2)  # add the loop to the experiment
thisTrial_2 = trials_2.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
if thisTrial_2 != None:
    for paramName in thisTrial_2:
        exec('{} = thisTrial_2[paramName]'.format(paramName))

for thisTrial_2 in trials_2:
    currentLoop = trials_2
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_2.rgb)
    if thisTrial_2 != None:
        for paramName in thisTrial_2:
            exec('{} = thisTrial_2[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    trials = data.TrialHandler(nReps=50.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(Task),
        seed=None, name='trials')
    thisExp.addLoop(trials)  # add the loop to the experiment
    thisTrial = trials.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
    if thisTrial != None:
        for paramName in thisTrial:
            exec('{} = thisTrial[paramName]'.format(paramName))
    
    for thisTrial in trials:
        currentLoop = trials
        # abbreviate parameter names if possible (e.g. rgb = thisTrial.rgb)
        if thisTrial != None:
            for paramName in thisTrial:
                exec('{} = thisTrial[paramName]'.format(paramName))
        
        # ------Prepare to start Routine "trial"-------
        continueRoutine = True
        # update component parameters for each repeat
        # immediate feedback
        if Feedback_Type == 'Immediate':
            ax = -.6
            ay = .01
            bx = -.25
            by = .01
            
        # delayed feedback
        if Feedback_Type == 'Delayed':
            ax = -.6
            ay = .01
            bx = -.25
            by = .01
            
        # oneback feedback
        if Feedback_Type == 'Oneback':
            if Top_Bott == 'Top':
                ax =  -.6
                ay = .27
                bx = -.25
                by = .27
            if Top_Bott == 'Bottom':
                ax = -.6
                ay = -.3
                bx = -.25
                by = -.3
                
        # deferred feedback        
        if Feedback_Type == 'Deferred':
            ax = -.6
            ay = .01
            bx = -.25
            by = .01
        
        
        image.setImage(Stim)
        key_resp.keys = []
        key_resp.rt = []
        _key_resp_allKeys = []
        A_text.setPos((ax,ay))
        A_text.setText('A')
        B_text.setPos((bx,by))
        B_text.setText('B')
        # keep track of which components have finished
        trialComponents = [image, key_resp, A_text, B_text]
        for thisComponent in trialComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        trialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "trial"-------
        while continueRoutine:
            # get current time
            t = trialClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=trialClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *image* updates
            if image.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                image.frameNStart = frameN  # exact frame index
                image.tStart = t  # local t and not account for scr refresh
                image.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(image, 'tStartRefresh')  # time at next scr refresh
                image.setAutoDraw(True)
            
            # *key_resp* updates
            waitOnFlip = False
            if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                key_resp.frameNStart = frameN  # exact frame index
                key_resp.tStart = t  # local t and not account for scr refresh
                key_resp.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
                key_resp.status = STARTED
                # keyboard checking is just starting
                waitOnFlip = True
                win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
                win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
            if key_resp.status == STARTED and not waitOnFlip:
                theseKeys = key_resp.getKeys(keyList=['a','b'], waitRelease=False)
                _key_resp_allKeys.extend(theseKeys)
                if len(_key_resp_allKeys):
                    key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
                    key_resp.rt = _key_resp_allKeys[-1].rt
                    # was this correct?
                    if (key_resp.keys == str(Corr_Ans)) or (key_resp.keys == Corr_Ans):
                        key_resp.corr = 1
                    else:
                        key_resp.corr = 0
                    # a response ends the routine
                    continueRoutine = False
            
            # *A_text* updates
            if A_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                A_text.frameNStart = frameN  # exact frame index
                A_text.tStart = t  # local t and not account for scr refresh
                A_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(A_text, 'tStartRefresh')  # time at next scr refresh
                A_text.setAutoDraw(True)
            
            # *B_text* updates
            if B_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                # keep track of start time/frame for later
                B_text.frameNStart = frameN  # exact frame index
                B_text.tStart = t  # local t and not account for scr refresh
                B_text.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(B_text, 'tStartRefresh')  # time at next scr refresh
                B_text.setAutoDraw(True)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in trialComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "trial"-------
        for thisComponent in trialComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        trials.addData('image.started', image.tStartRefresh)
        trials.addData('image.stopped', image.tStopRefresh)
        # check responses
        if key_resp.keys in ['', [], None]:  # No response was made
            key_resp.keys = None
            # was no response the correct answer?!
            if str(Corr_Ans).lower() == 'none':
               key_resp.corr = 1;  # correct non-response
            else:
               key_resp.corr = 0;  # failed to respond (incorrectly)
        # store data for trials (TrialHandler)
        trials.addData('key_resp.keys',key_resp.keys)
        trials.addData('key_resp.corr', key_resp.corr)
        if key_resp.keys != None:  # we had a response
            trials.addData('key_resp.rt', key_resp.rt)
        trials.addData('key_resp.started', key_resp.tStartRefresh)
        trials.addData('key_resp.stopped', key_resp.tStopRefresh)
        trials.addData('A_text.started', A_text.tStartRefresh)
        trials.addData('A_text.stopped', A_text.tStopRefresh)
        trials.addData('B_text.started', B_text.tStartRefresh)
        trials.addData('B_text.stopped', B_text.tStopRefresh)
        # the Routine "trial" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # ------Prepare to start Routine "feedback"-------
        continueRoutine = True
        # update component parameters for each repeat
        # append the last accuracy value
        corr_history.append(key_resp.corr)
        Feedback_img_list.append(Feedback_img)
        trial_num = trials.thisN + 1
        
        # immediate feedback
        if Feedback_Type == 'Immediate':
            conditional = False
            feedback_onset = 0
            feedback_img_onset = 0
            show_stim = 'images/white.jpg'
            if corr_history[-1] == 1:
                score = score + 1
                response = "Correct +1 point. Total points: " + str(score)
                timeout = 1.5
            else:
                score = score - 1
                response = "Incorrect -1 point. Total points: " + str(score)
                timeout = 4
        
        # delayed feedback
        if Feedback_Type == 'Delayed':
            conditional = False
            feedback_onset = 6
            feedback_img_onset = 6
            show_stim = 'images/green.jpg'
            if corr_history[-1] == 1:
                score = score + 1        
                response = "Correct +1 point. Total points: " + str(score)
                timeout = 1.5
            else:
                score = score - 1 
                response = "Incorrect -1 point. Total points: " + str(score)
                timeout = 4
                
        # oneback feedback
        if Feedback_Type == 'Oneback':
            conditional = False
            show_stim = 'images/gray.jpg'
            if trials.thisN == 0:
                response = ' '
                timeout = 0
                feedback_onset = 0
                if corr_history[-1] == 1:
                    score = score + 1
                else:
                    score = score - 1
            if trials.thisN >= 1:
                show_stim = Feedback_img_list[-2]
                if corr_history[-2] == 1:
                    feedback_img_onset = 1.5
                    feedback_onset = 1.5
                    timeout = 1.5
                    score = score + 1
                    if trial_num % 2 == 0:    
                        response = "Last TOP trial Correct +1 point. Total points: " + str(score)
                    else: 
                        response = "Last BOTTOM trial Correct +1 point. Total points: " +str(score)
                else:
                    feedback_img_onset = 4
                    timeout = 4
                    feedback_onset = 4
                    score = score - 1
                    if trial_num % 2 > 0:
                        response = "Last TOP trial Incorrect -1 point. Total points: " + str(score)
                    else: 
                        response = "Last BOTTOM trial Incorrect -1 point. Total points: " + str(score)
                        
        # deferred feedback        
        if Feedback_Type == 'Deferred':
            show_stim = 'images/pink.jpg'
            feedback_onset = 0    
            feedback_img_onset = 0
            if trial_num % 6 == 0:
                conditional = True
            else:
                response = ' '
                timeout = .1
                conditional = False
        
        thisExp.addData('corr_history',corr_history)
        image_2.setImage(show_stim)
        fdbk.setText(response)
        # keep track of which components have finished
        feedbackComponents = [image_2, fdbk]
        for thisComponent in feedbackComponents:
            thisComponent.tStart = None
            thisComponent.tStop = None
            thisComponent.tStartRefresh = None
            thisComponent.tStopRefresh = None
            if hasattr(thisComponent, 'status'):
                thisComponent.status = NOT_STARTED
        # reset timers
        t = 0
        _timeToFirstFrame = win.getFutureFlipTime(clock="now")
        feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
        frameN = -1
        
        # -------Run Routine "feedback"-------
        while continueRoutine:
            # get current time
            t = feedbackClock.getTime()
            tThisFlip = win.getFutureFlipTime(clock=feedbackClock)
            tThisFlipGlobal = win.getFutureFlipTime(clock=None)
            frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
            # update/draw components on each frame
            
            # *image_2* updates
            if image_2.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                # keep track of start time/frame for later
                image_2.frameNStart = frameN  # exact frame index
                image_2.tStart = t  # local t and not account for scr refresh
                image_2.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(image_2, 'tStartRefresh')  # time at next scr refresh
                image_2.setAutoDraw(True)
            if image_2.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > image_2.tStartRefresh + feedback_img_onset + timeout-frameTolerance:
                    # keep track of stop time/frame for later
                    image_2.tStop = t  # not accounting for scr refresh
                    image_2.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(image_2, 'tStopRefresh')  # time at next scr refresh
                    image_2.setAutoDraw(False)
            
            # *fdbk* updates
            if fdbk.status == NOT_STARTED and tThisFlip >= feedback_onset-frameTolerance:
                # keep track of start time/frame for later
                fdbk.frameNStart = frameN  # exact frame index
                fdbk.tStart = t  # local t and not account for scr refresh
                fdbk.tStartRefresh = tThisFlipGlobal  # on global time
                win.timeOnFlip(fdbk, 'tStartRefresh')  # time at next scr refresh
                fdbk.setAutoDraw(True)
            if fdbk.status == STARTED:
                # is it time to stop? (based on global clock, using actual start)
                if tThisFlipGlobal > fdbk.tStartRefresh + timeout-frameTolerance:
                    # keep track of stop time/frame for later
                    fdbk.tStop = t  # not accounting for scr refresh
                    fdbk.frameNStop = frameN  # exact frame index
                    win.timeOnFlip(fdbk, 'tStopRefresh')  # time at next scr refresh
                    fdbk.setAutoDraw(False)
            
            # check for quit (typically the Esc key)
            if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                core.quit()
            
            # check if all components have finished
            if not continueRoutine:  # a component has requested a forced-end of Routine
                break
            continueRoutine = False  # will revert to True if at least one component still running
            for thisComponent in feedbackComponents:
                if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                    continueRoutine = True
                    break  # at least one component has not yet finished
            
            # refresh the screen
            if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                win.flip()
        
        # -------Ending Routine "feedback"-------
        for thisComponent in feedbackComponents:
            if hasattr(thisComponent, "setAutoDraw"):
                thisComponent.setAutoDraw(False)
        if Feedback_Type == 'Immediate' or 'Delayed' or 'Oneback':
            last30 = corr_history[-30:]
            avg_acc = (sum(last30))/30
            if(avg_acc >=0.8 and trial_num >= 30):
                trials.finished = True
        # the Routine "feedback" was not non-slip safe, so reset the non-slip timer
        routineTimer.reset()
        
        # set up handler to look after randomisation of conditions etc
        defer_loop = data.TrialHandler(nReps=int(conditional), method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=[None],
            seed=None, name='defer_loop')
        thisExp.addLoop(defer_loop)  # add the loop to the experiment
        thisDefer_loop = defer_loop.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisDefer_loop.rgb)
        if thisDefer_loop != None:
            for paramName in thisDefer_loop:
                exec('{} = thisDefer_loop[paramName]'.format(paramName))
        
        for thisDefer_loop in defer_loop:
            currentLoop = defer_loop
            # abbreviate parameter names if possible (e.g. rgb = thisDefer_loop.rgb)
            if thisDefer_loop != None:
                for paramName in thisDefer_loop:
                    exec('{} = thisDefer_loop[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "def_feedback"-------
            continueRoutine = True
            # update component parameters for each repeat
            # deferred feedback        
            if corr_history[-6] == 1:
                score = score + 1
                def1 = 'Correct +1 point. Total Points: ' + str(score)
                timeout = 1.0
            else:
                score = score - 1
                def1 = 'Incorrect -1 point. Total Points: ' + str(score)
                timeout = 4.0
            if corr_history[-5] == 1:
                score = score + 1
                def2 = 'Correct +1 point. Total Points: ' + str(score)
                timeout = 1
            else: 
                score = score - 1
                def2 = 'Incorrect -1 point. Total Points: ' + str(score)
                timeout = 4
            if corr_history[-4] == 1:
                score = score + 1
                def3 = 'Correct +1 point. Total Points: ' + str(score)
                timeout = 1
            else:
                score = score - 1
                def3 = 'Incorrect -1 point. Total Points: ' + str(score)
                timeout = 4
            if corr_history[-3] == 1:
                score = score + 1
                def4 = 'Correct +1 point. Total Points: ' + str(score)
                timeout = 1
            else:
                score = score - 1
                def4 = 'Incorrect -1 point. Total Points: ' + str(score)
                timeout = 4
            if corr_history[-2] == 1:
                score = score + 1
                def5 = 'Correct +1 point. Total Points: ' + str(score)
                timeout = 1
            else:
                score = score - 1
                def5 = 'Incorrect -1 point. Total Points: ' + str(score)
                timeout = 4
            if corr_history[-1] == 1:
                score = score + 1
                def6 = 'Correct +1 point. Total Points: ' + str(score)
                timeout = 1
            else:
                score = score - 1
                def6 = 'Incorrect -1 point. Total Points: ' + str(score)
                timeout = 4
            
            deferred_trial1.setText(def1)
            deferred_trial2.setText(def2)
            deferred_trial3.setText(def3)
            deferred_trial4.setText(def4)
            deferred_trial5.setText(def5)
            deferred_trial6.setText(def6)
            # keep track of which components have finished
            def_feedbackComponents = [deferred_trial1, deferred_trial2, deferred_trial3, deferred_trial4, deferred_trial5, deferred_trial6]
            for thisComponent in def_feedbackComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            def_feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "def_feedback"-------
            while continueRoutine:
                # get current time
                t = def_feedbackClock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=def_feedbackClock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *deferred_trial1* updates
                if deferred_trial1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    deferred_trial1.frameNStart = frameN  # exact frame index
                    deferred_trial1.tStart = t  # local t and not account for scr refresh
                    deferred_trial1.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(deferred_trial1, 'tStartRefresh')  # time at next scr refresh
                    deferred_trial1.setAutoDraw(True)
                if deferred_trial1.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > deferred_trial1.tStartRefresh + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        deferred_trial1.tStop = t  # not accounting for scr refresh
                        deferred_trial1.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(deferred_trial1, 'tStopRefresh')  # time at next scr refresh
                        deferred_trial1.setAutoDraw(False)
                
                # *deferred_trial2* updates
                if deferred_trial2.status == NOT_STARTED and deferred_trial1.status==FINISHED:
                    # keep track of start time/frame for later
                    deferred_trial2.frameNStart = frameN  # exact frame index
                    deferred_trial2.tStart = t  # local t and not account for scr refresh
                    deferred_trial2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(deferred_trial2, 'tStartRefresh')  # time at next scr refresh
                    deferred_trial2.setAutoDraw(True)
                if deferred_trial2.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > deferred_trial2.tStartRefresh + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        deferred_trial2.tStop = t  # not accounting for scr refresh
                        deferred_trial2.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(deferred_trial2, 'tStopRefresh')  # time at next scr refresh
                        deferred_trial2.setAutoDraw(False)
                
                # *deferred_trial3* updates
                if deferred_trial3.status == NOT_STARTED and deferred_trial2.status==FINISHED:
                    # keep track of start time/frame for later
                    deferred_trial3.frameNStart = frameN  # exact frame index
                    deferred_trial3.tStart = t  # local t and not account for scr refresh
                    deferred_trial3.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(deferred_trial3, 'tStartRefresh')  # time at next scr refresh
                    deferred_trial3.setAutoDraw(True)
                if deferred_trial3.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > deferred_trial3.tStartRefresh + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        deferred_trial3.tStop = t  # not accounting for scr refresh
                        deferred_trial3.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(deferred_trial3, 'tStopRefresh')  # time at next scr refresh
                        deferred_trial3.setAutoDraw(False)
                
                # *deferred_trial4* updates
                if deferred_trial4.status == NOT_STARTED and deferred_trial3.status==FINISHED:
                    # keep track of start time/frame for later
                    deferred_trial4.frameNStart = frameN  # exact frame index
                    deferred_trial4.tStart = t  # local t and not account for scr refresh
                    deferred_trial4.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(deferred_trial4, 'tStartRefresh')  # time at next scr refresh
                    deferred_trial4.setAutoDraw(True)
                if deferred_trial4.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > deferred_trial4.tStartRefresh + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        deferred_trial4.tStop = t  # not accounting for scr refresh
                        deferred_trial4.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(deferred_trial4, 'tStopRefresh')  # time at next scr refresh
                        deferred_trial4.setAutoDraw(False)
                
                # *deferred_trial5* updates
                if deferred_trial5.status == NOT_STARTED and deferred_trial4.status==FINISHED:
                    # keep track of start time/frame for later
                    deferred_trial5.frameNStart = frameN  # exact frame index
                    deferred_trial5.tStart = t  # local t and not account for scr refresh
                    deferred_trial5.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(deferred_trial5, 'tStartRefresh')  # time at next scr refresh
                    deferred_trial5.setAutoDraw(True)
                if deferred_trial5.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > deferred_trial5.tStartRefresh + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        deferred_trial5.tStop = t  # not accounting for scr refresh
                        deferred_trial5.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(deferred_trial5, 'tStopRefresh')  # time at next scr refresh
                        deferred_trial5.setAutoDraw(False)
                
                # *deferred_trial6* updates
                if deferred_trial6.status == NOT_STARTED and deferred_trial5.status==FINISHED:
                    # keep track of start time/frame for later
                    deferred_trial6.frameNStart = frameN  # exact frame index
                    deferred_trial6.tStart = t  # local t and not account for scr refresh
                    deferred_trial6.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(deferred_trial6, 'tStartRefresh')  # time at next scr refresh
                    deferred_trial6.setAutoDraw(True)
                if deferred_trial6.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > deferred_trial6.tStartRefresh + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        deferred_trial6.tStop = t  # not accounting for scr refresh
                        deferred_trial6.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(deferred_trial6, 'tStopRefresh')  # time at next scr refresh
                        deferred_trial6.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in def_feedbackComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "def_feedback"-------
            for thisComponent in def_feedbackComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            if trial_num % 6 == 0:
                last30 = corr_history[-30:]
                avg_acc = (sum(last30))/30
                if(avg_acc >=0.8 and trial_num >= 30):
                    trials.finished = True
            if trial_num % 6 > 0:
                trials.finished = False
            defer_loop.addData('deferred_trial1.started', deferred_trial1.tStartRefresh)
            defer_loop.addData('deferred_trial1.stopped', deferred_trial1.tStopRefresh)
            defer_loop.addData('deferred_trial2.started', deferred_trial2.tStartRefresh)
            defer_loop.addData('deferred_trial2.stopped', deferred_trial2.tStopRefresh)
            defer_loop.addData('deferred_trial3.started', deferred_trial3.tStartRefresh)
            defer_loop.addData('deferred_trial3.stopped', deferred_trial3.tStopRefresh)
            defer_loop.addData('deferred_trial4.started', deferred_trial4.tStartRefresh)
            defer_loop.addData('deferred_trial4.stopped', deferred_trial4.tStopRefresh)
            defer_loop.addData('deferred_trial5.started', deferred_trial5.tStartRefresh)
            defer_loop.addData('deferred_trial5.stopped', deferred_trial5.tStopRefresh)
            defer_loop.addData('deferred_trial6.started', deferred_trial6.tStartRefresh)
            defer_loop.addData('deferred_trial6.stopped', deferred_trial6.tStopRefresh)
            # the Routine "def_feedback" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
        # completed int(conditional) repeats of 'defer_loop'
        
        thisExp.nextEntry()
        
    # completed 50.0 repeats of 'trials'
    
# completed 1.0 repeats of 'trials_2'


# set up handler to look after randomisation of conditions etc
trials_7 = data.TrialHandler(nReps=1.0, method='random', 
    extraInfo=expInfo, originPath=-1,
    trialList=data.importConditions('Test_Order1.xlsx'),
    seed=None, name='trials_7')
thisExp.addLoop(trials_7)  # add the loop to the experiment
thisTrial_7 = trials_7.trialList[0]  # so we can initialise stimuli with some values
# abbreviate parameter names if possible (e.g. rgb = thisTrial_7.rgb)
if thisTrial_7 != None:
    for paramName in thisTrial_7:
        exec('{} = thisTrial_7[paramName]'.format(paramName))

for thisTrial_7 in trials_7:
    currentLoop = trials_7
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_7.rgb)
    if thisTrial_7 != None:
        for paramName in thisTrial_7:
            exec('{} = thisTrial_7[paramName]'.format(paramName))
    
    # set up handler to look after randomisation of conditions etc
    trials_6 = data.TrialHandler(nReps=1.0, method='sequential', 
        extraInfo=expInfo, originPath=-1,
        trialList=data.importConditions(Test_Order),
        seed=None, name='trials_6')
    thisExp.addLoop(trials_6)  # add the loop to the experiment
    thisTrial_6 = trials_6.trialList[0]  # so we can initialise stimuli with some values
    # abbreviate parameter names if possible (e.g. rgb = thisTrial_6.rgb)
    if thisTrial_6 != None:
        for paramName in thisTrial_6:
            exec('{} = thisTrial_6[paramName]'.format(paramName))
    
    for thisTrial_6 in trials_6:
        currentLoop = trials_6
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_6.rgb)
        if thisTrial_6 != None:
            for paramName in thisTrial_6:
                exec('{} = thisTrial_6[paramName]'.format(paramName))
        
        # set up handler to look after randomisation of conditions etc
        trials_5 = data.TrialHandler(nReps=50.0, method='sequential', 
            extraInfo=expInfo, originPath=-1,
            trialList=data.importConditions(Tasks),
            seed=None, name='trials_5')
        thisExp.addLoop(trials_5)  # add the loop to the experiment
        thisTrial_5 = trials_5.trialList[0]  # so we can initialise stimuli with some values
        # abbreviate parameter names if possible (e.g. rgb = thisTrial_5.rgb)
        if thisTrial_5 != None:
            for paramName in thisTrial_5:
                exec('{} = thisTrial_5[paramName]'.format(paramName))
        
        for thisTrial_5 in trials_5:
            currentLoop = trials_5
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_5.rgb)
            if thisTrial_5 != None:
                for paramName in thisTrial_5:
                    exec('{} = thisTrial_5[paramName]'.format(paramName))
            
            # ------Prepare to start Routine "trial"-------
            continueRoutine = True
            # update component parameters for each repeat
            # immediate feedback
            if Feedback_Type == 'Immediate':
                ax = -.6
                ay = .01
                bx = -.25
                by = .01
                
            # delayed feedback
            if Feedback_Type == 'Delayed':
                ax = -.6
                ay = .01
                bx = -.25
                by = .01
                
            # oneback feedback
            if Feedback_Type == 'Oneback':
                if Top_Bott == 'Top':
                    ax =  -.6
                    ay = .27
                    bx = -.25
                    by = .27
                if Top_Bott == 'Bottom':
                    ax = -.6
                    ay = -.3
                    bx = -.25
                    by = -.3
                    
            # deferred feedback        
            if Feedback_Type == 'Deferred':
                ax = -.6
                ay = .01
                bx = -.25
                by = .01
            
            
            image.setImage(Stim)
            key_resp.keys = []
            key_resp.rt = []
            _key_resp_allKeys = []
            A_text.setPos((ax,ay))
            A_text.setText('A')
            B_text.setPos((bx,by))
            B_text.setText('B')
            # keep track of which components have finished
            trialComponents = [image, key_resp, A_text, B_text]
            for thisComponent in trialComponents:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            trialClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "trial"-------
            while continueRoutine:
                # get current time
                t = trialClock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=trialClock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *image* updates
                if image.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    image.frameNStart = frameN  # exact frame index
                    image.tStart = t  # local t and not account for scr refresh
                    image.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(image, 'tStartRefresh')  # time at next scr refresh
                    image.setAutoDraw(True)
                
                # *key_resp* updates
                waitOnFlip = False
                if key_resp.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    key_resp.frameNStart = frameN  # exact frame index
                    key_resp.tStart = t  # local t and not account for scr refresh
                    key_resp.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(key_resp, 'tStartRefresh')  # time at next scr refresh
                    key_resp.status = STARTED
                    # keyboard checking is just starting
                    waitOnFlip = True
                    win.callOnFlip(key_resp.clock.reset)  # t=0 on next screen flip
                    win.callOnFlip(key_resp.clearEvents, eventType='keyboard')  # clear events on next screen flip
                if key_resp.status == STARTED and not waitOnFlip:
                    theseKeys = key_resp.getKeys(keyList=['a','b'], waitRelease=False)
                    _key_resp_allKeys.extend(theseKeys)
                    if len(_key_resp_allKeys):
                        key_resp.keys = _key_resp_allKeys[-1].name  # just the last key pressed
                        key_resp.rt = _key_resp_allKeys[-1].rt
                        # was this correct?
                        if (key_resp.keys == str(Corr_Ans)) or (key_resp.keys == Corr_Ans):
                            key_resp.corr = 1
                        else:
                            key_resp.corr = 0
                        # a response ends the routine
                        continueRoutine = False
                
                # *A_text* updates
                if A_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    A_text.frameNStart = frameN  # exact frame index
                    A_text.tStart = t  # local t and not account for scr refresh
                    A_text.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(A_text, 'tStartRefresh')  # time at next scr refresh
                    A_text.setAutoDraw(True)
                
                # *B_text* updates
                if B_text.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                    # keep track of start time/frame for later
                    B_text.frameNStart = frameN  # exact frame index
                    B_text.tStart = t  # local t and not account for scr refresh
                    B_text.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(B_text, 'tStartRefresh')  # time at next scr refresh
                    B_text.setAutoDraw(True)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in trialComponents:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "trial"-------
            for thisComponent in trialComponents:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            trials_5.addData('image.started', image.tStartRefresh)
            trials_5.addData('image.stopped', image.tStopRefresh)
            # check responses
            if key_resp.keys in ['', [], None]:  # No response was made
                key_resp.keys = None
                # was no response the correct answer?!
                if str(Corr_Ans).lower() == 'none':
                   key_resp.corr = 1;  # correct non-response
                else:
                   key_resp.corr = 0;  # failed to respond (incorrectly)
            # store data for trials_5 (TrialHandler)
            trials_5.addData('key_resp.keys',key_resp.keys)
            trials_5.addData('key_resp.corr', key_resp.corr)
            if key_resp.keys != None:  # we had a response
                trials_5.addData('key_resp.rt', key_resp.rt)
            trials_5.addData('key_resp.started', key_resp.tStartRefresh)
            trials_5.addData('key_resp.stopped', key_resp.tStopRefresh)
            trials_5.addData('A_text.started', A_text.tStartRefresh)
            trials_5.addData('A_text.stopped', A_text.tStopRefresh)
            trials_5.addData('B_text.started', B_text.tStartRefresh)
            trials_5.addData('B_text.stopped', B_text.tStopRefresh)
            # the Routine "trial" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            
            # ------Prepare to start Routine "feedback2"-------
            continueRoutine = True
            # update component parameters for each repeat
            # append the last accuracy value
            corr_history.append(key_resp.corr)
            Feedback_img_list.append(Feedback_img)
            trial_num = trials_5.thisN + 1
            
            # immediate feedback
            if Feedback_Type == 'Immediate':
                conditional = False
                feedback_onset = 0
                feedback_img_onset = 0
                show_stim = 'images/white.jpg'
                timeout = .5
                if corr_history[-1] == 1:
                    score = score + 1
                    response = "Correct +1 point. Total points: " + str(score)
                    timeout = 1.5
                else:
                    score = score - 1
                    response = "Incorrect -1 point. Total points: " + str(score)
                    timeout = 4
            
            # delayed feedback
            if Feedback_Type == 'Delayed':
                conditional = False
                feedback_onset = 6
                feedback_img_onset = 6
                show_stim = 'images/green.jpg'
                if corr_history[-1] == 1:
                    score = score + 1        
                    response = "Correct +1 point. Total points: " + str(score)
                    timeout = 1.5
                else:
                    score = score - 1 
                    response = "Incorrect -1 point. Total points: " + str(score)
                    timeout = 4
                    
            # oneback feedback
            if Feedback_Type == 'Oneback':
                conditional = False
                if trials_5.thisN == 0:
                    response = ' '
                    timeout = 0
                    feedback_onset = 0
                    show_stim = 'images/gray.jpg'
                    if corr_history[-1] == 1:
                        score = score + 1
                    else:
                        score = score - 1
                if trials_5.thisN >= 1:
                    show_stim = Feedback_img_list[-2]
                    if corr_history[-2] == 1:
                        feedback_img_onset = 1.5
                        feedback_onset = 1.5
                        timeout = 1.5
                        score = score + 1
                        if trial_num % 2 == 0:    
                            response = "Last TOP trial Correct +1 point. Total points: " + str(score)
                        else: 
                            response = "Last BOTTOM trial Correct +1 point. Total points: " +str(score)
                    else:
                        feedback_img_onset = 4
                        timeout = 4
                        feedback_onset = 4
                        score = score - 1
                        if trial_num % 2 > 0:
                            response = "Last TOP trial Incorrect -1 point. Total points: " + str(score)
                        else: 
                            response = "Last BOTTOM trial Incorrect -1 point. Total points: " + str(score)
                            
            # deferred feedback        
            if Feedback_Type == 'Deferred':
                show_stim = 'images/pink.jpg'
                feedback_onset = 0    
                feedback_img_onset = 0
                if trial_num % 6 == 0:
                    conditional = True
                else:
                    response = ' '
                    timeout = .1
                    conditional = False
            
            thisExp.addData('corr_history',corr_history)
            image_6.setImage(show_stim)
            fdbk_2.setText(response)
            # keep track of which components have finished
            feedback2Components = [image_6, fdbk_2]
            for thisComponent in feedback2Components:
                thisComponent.tStart = None
                thisComponent.tStop = None
                thisComponent.tStartRefresh = None
                thisComponent.tStopRefresh = None
                if hasattr(thisComponent, 'status'):
                    thisComponent.status = NOT_STARTED
            # reset timers
            t = 0
            _timeToFirstFrame = win.getFutureFlipTime(clock="now")
            feedback2Clock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
            frameN = -1
            
            # -------Run Routine "feedback2"-------
            while continueRoutine:
                # get current time
                t = feedback2Clock.getTime()
                tThisFlip = win.getFutureFlipTime(clock=feedback2Clock)
                tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                # update/draw components on each frame
                
                # *image_6* updates
                if image_6.status == NOT_STARTED and tThisFlip >= 0-frameTolerance:
                    # keep track of start time/frame for later
                    image_6.frameNStart = frameN  # exact frame index
                    image_6.tStart = t  # local t and not account for scr refresh
                    image_6.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(image_6, 'tStartRefresh')  # time at next scr refresh
                    image_6.setAutoDraw(True)
                if image_6.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > image_6.tStartRefresh + feedback_img_onset + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        image_6.tStop = t  # not accounting for scr refresh
                        image_6.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(image_6, 'tStopRefresh')  # time at next scr refresh
                        image_6.setAutoDraw(False)
                
                # *fdbk_2* updates
                if fdbk_2.status == NOT_STARTED and tThisFlip >= feedback_onset-frameTolerance:
                    # keep track of start time/frame for later
                    fdbk_2.frameNStart = frameN  # exact frame index
                    fdbk_2.tStart = t  # local t and not account for scr refresh
                    fdbk_2.tStartRefresh = tThisFlipGlobal  # on global time
                    win.timeOnFlip(fdbk_2, 'tStartRefresh')  # time at next scr refresh
                    fdbk_2.setAutoDraw(True)
                if fdbk_2.status == STARTED:
                    # is it time to stop? (based on global clock, using actual start)
                    if tThisFlipGlobal > fdbk_2.tStartRefresh + timeout-frameTolerance:
                        # keep track of stop time/frame for later
                        fdbk_2.tStop = t  # not accounting for scr refresh
                        fdbk_2.frameNStop = frameN  # exact frame index
                        win.timeOnFlip(fdbk_2, 'tStopRefresh')  # time at next scr refresh
                        fdbk_2.setAutoDraw(False)
                
                # check for quit (typically the Esc key)
                if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                    core.quit()
                
                # check if all components have finished
                if not continueRoutine:  # a component has requested a forced-end of Routine
                    break
                continueRoutine = False  # will revert to True if at least one component still running
                for thisComponent in feedback2Components:
                    if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                        continueRoutine = True
                        break  # at least one component has not yet finished
                
                # refresh the screen
                if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                    win.flip()
            
            # -------Ending Routine "feedback2"-------
            for thisComponent in feedback2Components:
                if hasattr(thisComponent, "setAutoDraw"):
                    thisComponent.setAutoDraw(False)
            last30 = corr_history[-30:]
            avg_acc = (sum(last30))/30
            if Feedback_Type == 'Immediate' or 'Delayed' or 'Oneback':
                if(avg_acc >=0.8 and trial_num >= 30):
                    task_ctr = task_ctr + 1
                    trials_5.finished = True
                    if task_ctr == 5:
                        trials_7.finished = True
                
            
            # the Routine "feedback2" was not non-slip safe, so reset the non-slip timer
            routineTimer.reset()
            
            # set up handler to look after randomisation of conditions etc
            trials_4 = data.TrialHandler(nReps=int(conditional), method='sequential', 
                extraInfo=expInfo, originPath=-1,
                trialList=[None],
                seed=None, name='trials_4')
            thisExp.addLoop(trials_4)  # add the loop to the experiment
            thisTrial_4 = trials_4.trialList[0]  # so we can initialise stimuli with some values
            # abbreviate parameter names if possible (e.g. rgb = thisTrial_4.rgb)
            if thisTrial_4 != None:
                for paramName in thisTrial_4:
                    exec('{} = thisTrial_4[paramName]'.format(paramName))
            
            for thisTrial_4 in trials_4:
                currentLoop = trials_4
                # abbreviate parameter names if possible (e.g. rgb = thisTrial_4.rgb)
                if thisTrial_4 != None:
                    for paramName in thisTrial_4:
                        exec('{} = thisTrial_4[paramName]'.format(paramName))
                
                # ------Prepare to start Routine "def_feedback"-------
                continueRoutine = True
                # update component parameters for each repeat
                # deferred feedback        
                if corr_history[-6] == 1:
                    score = score + 1
                    def1 = 'Correct +1 point. Total Points: ' + str(score)
                    timeout = 1.0
                else:
                    score = score - 1
                    def1 = 'Incorrect -1 point. Total Points: ' + str(score)
                    timeout = 4.0
                if corr_history[-5] == 1:
                    score = score + 1
                    def2 = 'Correct +1 point. Total Points: ' + str(score)
                    timeout = 1
                else: 
                    score = score - 1
                    def2 = 'Incorrect -1 point. Total Points: ' + str(score)
                    timeout = 4
                if corr_history[-4] == 1:
                    score = score + 1
                    def3 = 'Correct +1 point. Total Points: ' + str(score)
                    timeout = 1
                else:
                    score = score - 1
                    def3 = 'Incorrect -1 point. Total Points: ' + str(score)
                    timeout = 4
                if corr_history[-3] == 1:
                    score = score + 1
                    def4 = 'Correct +1 point. Total Points: ' + str(score)
                    timeout = 1
                else:
                    score = score - 1
                    def4 = 'Incorrect -1 point. Total Points: ' + str(score)
                    timeout = 4
                if corr_history[-2] == 1:
                    score = score + 1
                    def5 = 'Correct +1 point. Total Points: ' + str(score)
                    timeout = 1
                else:
                    score = score - 1
                    def5 = 'Incorrect -1 point. Total Points: ' + str(score)
                    timeout = 4
                if corr_history[-1] == 1:
                    score = score + 1
                    def6 = 'Correct +1 point. Total Points: ' + str(score)
                    timeout = 1
                else:
                    score = score - 1
                    def6 = 'Incorrect -1 point. Total Points: ' + str(score)
                    timeout = 4
                
                deferred_trial1.setText(def1)
                deferred_trial2.setText(def2)
                deferred_trial3.setText(def3)
                deferred_trial4.setText(def4)
                deferred_trial5.setText(def5)
                deferred_trial6.setText(def6)
                # keep track of which components have finished
                def_feedbackComponents = [deferred_trial1, deferred_trial2, deferred_trial3, deferred_trial4, deferred_trial5, deferred_trial6]
                for thisComponent in def_feedbackComponents:
                    thisComponent.tStart = None
                    thisComponent.tStop = None
                    thisComponent.tStartRefresh = None
                    thisComponent.tStopRefresh = None
                    if hasattr(thisComponent, 'status'):
                        thisComponent.status = NOT_STARTED
                # reset timers
                t = 0
                _timeToFirstFrame = win.getFutureFlipTime(clock="now")
                def_feedbackClock.reset(-_timeToFirstFrame)  # t0 is time of first possible flip
                frameN = -1
                
                # -------Run Routine "def_feedback"-------
                while continueRoutine:
                    # get current time
                    t = def_feedbackClock.getTime()
                    tThisFlip = win.getFutureFlipTime(clock=def_feedbackClock)
                    tThisFlipGlobal = win.getFutureFlipTime(clock=None)
                    frameN = frameN + 1  # number of completed frames (so 0 is the first frame)
                    # update/draw components on each frame
                    
                    # *deferred_trial1* updates
                    if deferred_trial1.status == NOT_STARTED and tThisFlip >= 0.0-frameTolerance:
                        # keep track of start time/frame for later
                        deferred_trial1.frameNStart = frameN  # exact frame index
                        deferred_trial1.tStart = t  # local t and not account for scr refresh
                        deferred_trial1.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(deferred_trial1, 'tStartRefresh')  # time at next scr refresh
                        deferred_trial1.setAutoDraw(True)
                    if deferred_trial1.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > deferred_trial1.tStartRefresh + timeout-frameTolerance:
                            # keep track of stop time/frame for later
                            deferred_trial1.tStop = t  # not accounting for scr refresh
                            deferred_trial1.frameNStop = frameN  # exact frame index
                            win.timeOnFlip(deferred_trial1, 'tStopRefresh')  # time at next scr refresh
                            deferred_trial1.setAutoDraw(False)
                    
                    # *deferred_trial2* updates
                    if deferred_trial2.status == NOT_STARTED and deferred_trial1.status==FINISHED:
                        # keep track of start time/frame for later
                        deferred_trial2.frameNStart = frameN  # exact frame index
                        deferred_trial2.tStart = t  # local t and not account for scr refresh
                        deferred_trial2.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(deferred_trial2, 'tStartRefresh')  # time at next scr refresh
                        deferred_trial2.setAutoDraw(True)
                    if deferred_trial2.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > deferred_trial2.tStartRefresh + timeout-frameTolerance:
                            # keep track of stop time/frame for later
                            deferred_trial2.tStop = t  # not accounting for scr refresh
                            deferred_trial2.frameNStop = frameN  # exact frame index
                            win.timeOnFlip(deferred_trial2, 'tStopRefresh')  # time at next scr refresh
                            deferred_trial2.setAutoDraw(False)
                    
                    # *deferred_trial3* updates
                    if deferred_trial3.status == NOT_STARTED and deferred_trial2.status==FINISHED:
                        # keep track of start time/frame for later
                        deferred_trial3.frameNStart = frameN  # exact frame index
                        deferred_trial3.tStart = t  # local t and not account for scr refresh
                        deferred_trial3.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(deferred_trial3, 'tStartRefresh')  # time at next scr refresh
                        deferred_trial3.setAutoDraw(True)
                    if deferred_trial3.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > deferred_trial3.tStartRefresh + timeout-frameTolerance:
                            # keep track of stop time/frame for later
                            deferred_trial3.tStop = t  # not accounting for scr refresh
                            deferred_trial3.frameNStop = frameN  # exact frame index
                            win.timeOnFlip(deferred_trial3, 'tStopRefresh')  # time at next scr refresh
                            deferred_trial3.setAutoDraw(False)
                    
                    # *deferred_trial4* updates
                    if deferred_trial4.status == NOT_STARTED and deferred_trial3.status==FINISHED:
                        # keep track of start time/frame for later
                        deferred_trial4.frameNStart = frameN  # exact frame index
                        deferred_trial4.tStart = t  # local t and not account for scr refresh
                        deferred_trial4.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(deferred_trial4, 'tStartRefresh')  # time at next scr refresh
                        deferred_trial4.setAutoDraw(True)
                    if deferred_trial4.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > deferred_trial4.tStartRefresh + timeout-frameTolerance:
                            # keep track of stop time/frame for later
                            deferred_trial4.tStop = t  # not accounting for scr refresh
                            deferred_trial4.frameNStop = frameN  # exact frame index
                            win.timeOnFlip(deferred_trial4, 'tStopRefresh')  # time at next scr refresh
                            deferred_trial4.setAutoDraw(False)
                    
                    # *deferred_trial5* updates
                    if deferred_trial5.status == NOT_STARTED and deferred_trial4.status==FINISHED:
                        # keep track of start time/frame for later
                        deferred_trial5.frameNStart = frameN  # exact frame index
                        deferred_trial5.tStart = t  # local t and not account for scr refresh
                        deferred_trial5.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(deferred_trial5, 'tStartRefresh')  # time at next scr refresh
                        deferred_trial5.setAutoDraw(True)
                    if deferred_trial5.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > deferred_trial5.tStartRefresh + timeout-frameTolerance:
                            # keep track of stop time/frame for later
                            deferred_trial5.tStop = t  # not accounting for scr refresh
                            deferred_trial5.frameNStop = frameN  # exact frame index
                            win.timeOnFlip(deferred_trial5, 'tStopRefresh')  # time at next scr refresh
                            deferred_trial5.setAutoDraw(False)
                    
                    # *deferred_trial6* updates
                    if deferred_trial6.status == NOT_STARTED and deferred_trial5.status==FINISHED:
                        # keep track of start time/frame for later
                        deferred_trial6.frameNStart = frameN  # exact frame index
                        deferred_trial6.tStart = t  # local t and not account for scr refresh
                        deferred_trial6.tStartRefresh = tThisFlipGlobal  # on global time
                        win.timeOnFlip(deferred_trial6, 'tStartRefresh')  # time at next scr refresh
                        deferred_trial6.setAutoDraw(True)
                    if deferred_trial6.status == STARTED:
                        # is it time to stop? (based on global clock, using actual start)
                        if tThisFlipGlobal > deferred_trial6.tStartRefresh + timeout-frameTolerance:
                            # keep track of stop time/frame for later
                            deferred_trial6.tStop = t  # not accounting for scr refresh
                            deferred_trial6.frameNStop = frameN  # exact frame index
                            win.timeOnFlip(deferred_trial6, 'tStopRefresh')  # time at next scr refresh
                            deferred_trial6.setAutoDraw(False)
                    
                    # check for quit (typically the Esc key)
                    if endExpNow or defaultKeyboard.getKeys(keyList=["escape"]):
                        core.quit()
                    
                    # check if all components have finished
                    if not continueRoutine:  # a component has requested a forced-end of Routine
                        break
                    continueRoutine = False  # will revert to True if at least one component still running
                    for thisComponent in def_feedbackComponents:
                        if hasattr(thisComponent, "status") and thisComponent.status != FINISHED:
                            continueRoutine = True
                            break  # at least one component has not yet finished
                    
                    # refresh the screen
                    if continueRoutine:  # don't flip if this routine is over or we'll get a blank screen
                        win.flip()
                
                # -------Ending Routine "def_feedback"-------
                for thisComponent in def_feedbackComponents:
                    if hasattr(thisComponent, "setAutoDraw"):
                        thisComponent.setAutoDraw(False)
                if trial_num % 6 == 0:
                    last30 = corr_history[-30:]
                    avg_acc = (sum(last30))/30
                    if(avg_acc >=0.8 and trial_num >= 30):
                        trials.finished = True
                if trial_num % 6 > 0:
                    trials.finished = False
                trials_4.addData('deferred_trial1.started', deferred_trial1.tStartRefresh)
                trials_4.addData('deferred_trial1.stopped', deferred_trial1.tStopRefresh)
                trials_4.addData('deferred_trial2.started', deferred_trial2.tStartRefresh)
                trials_4.addData('deferred_trial2.stopped', deferred_trial2.tStopRefresh)
                trials_4.addData('deferred_trial3.started', deferred_trial3.tStartRefresh)
                trials_4.addData('deferred_trial3.stopped', deferred_trial3.tStopRefresh)
                trials_4.addData('deferred_trial4.started', deferred_trial4.tStartRefresh)
                trials_4.addData('deferred_trial4.stopped', deferred_trial4.tStopRefresh)
                trials_4.addData('deferred_trial5.started', deferred_trial5.tStartRefresh)
                trials_4.addData('deferred_trial5.stopped', deferred_trial5.tStopRefresh)
                trials_4.addData('deferred_trial6.started', deferred_trial6.tStartRefresh)
                trials_4.addData('deferred_trial6.stopped', deferred_trial6.tStopRefresh)
                # the Routine "def_feedback" was not non-slip safe, so reset the non-slip timer
                routineTimer.reset()
                thisExp.nextEntry()
                
            # completed int(conditional) repeats of 'trials_4'
            
            thisExp.nextEntry()
            
        # completed 50.0 repeats of 'trials_5'
        
    # completed 1.0 repeats of 'trials_6'
    
# completed 1.0 repeats of 'trials_7'


# Flip one final time so any remaining win.callOnFlip() 
# and win.timeOnFlip() tasks get executed before quitting
win.flip()

# these shouldn't be strictly necessary (should auto-save)
thisExp.saveAsWideText(filename+'.csv', delim='auto')
thisExp.saveAsPickle(filename)
# make sure everything is closed down
if eyetracker:
    eyetracker.setConnectionState(False)
thisExp.abort()  # or data files will save again on exit
win.close()
core.quit()
